buildFilesystem.sh 8.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232
  1. #!/bin/bash
  2. set -x
  3. set -e
  4. # Build fs, image
  5. # This file is part of PrawnOS (http://www.prawnos.com)
  6. # Copyright (c) 2018 Hal Emmerich <hal@halemmerich.com>
  7. # PrawnOS is free software: you can redistribute it and/or modify
  8. # it under the terms of the GNU General Public License version 2
  9. # as published by the Free Software Foundation.
  10. # PrawnOS is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. # You should have received a copy of the GNU General Public License
  15. # along with PrawnOS. If not, see <https://www.gnu.org/licenses/>.
  16. #Ensure Sudo
  17. if [ ! $UID = "0" ]
  18. then
  19. echo "Please run this script with sudo, or as root:"
  20. echo "sudo $0 $*"
  21. exit 1
  22. fi
  23. if [ -z "$1" ]
  24. then
  25. echo "No kernel version supplied"
  26. exit 1
  27. fi
  28. if [ -z "$2" ]
  29. then
  30. echo "No debian suite supplied"
  31. exit 1
  32. fi
  33. if [ -z "$3" ]
  34. then
  35. echo "No base file system image filename supplied"
  36. exit 1
  37. fi
  38. KVER=$1
  39. DEBIAN_SUITE=$2
  40. BASE=$3
  41. outmnt=$(mktemp -d -p `pwd`)
  42. outdev=/dev/loop5
  43. install_resources=resources/InstallResources
  44. build_resources=resources/BuildResources
  45. #A hacky way to ensure the loops are properly unmounted and the temp files are properly deleted.
  46. #Without this, a reboot is sometimes required to properly clean the loop devices and ensure a clean build
  47. cleanup() {
  48. set +e
  49. umount -l $outmnt > /dev/null 2>&1
  50. rmdir $outmnt > /dev/null 2>&1
  51. losetup -d $outdev > /dev/null 2>&1
  52. set +e
  53. umount -l $outmnt > /dev/null 2>&1
  54. rmdir $outmnt > /dev/null 2>&1
  55. losetup -d $outdev > /dev/null 2>&1
  56. }
  57. trap cleanup INT TERM EXIT
  58. #layout the partitons and write filesystem information
  59. create_image() {
  60. dd if=/dev/zero of=$1 bs=$3 count=$4 conv=sparse
  61. parted --script $1 mklabel gpt
  62. cgpt create $1
  63. kernel_start=8192
  64. kernel_size=65536
  65. cgpt add -i 1 -t kernel -b $kernel_start -s $kernel_size -l Kernel -S 1 -T 5 -P 10 $1
  66. #Now the main filesystem
  67. root_start=$(($kernel_start + $kernel_size))
  68. end=`cgpt show $1 | grep 'Sec GPT table' | awk '{print $1}'`
  69. root_size=$(($end - $root_start))
  70. cgpt add -i 2 -t data -b $root_start -s $root_size -l Root $1
  71. # $root_size is in 512 byte blocks while ext4 uses a block size of 1024 bytes
  72. losetup -P $2 $1
  73. mkfs.ext4 -F -b 1024 ${2}p2 $(($root_size / 2))
  74. # mount the / partition
  75. mount -o noatime ${2}p2 $5
  76. }
  77. build_install_crossystem() {
  78. # install crossystem
  79. apt install -y vboot-utils
  80. #install clang and pre-reqs
  81. apt install -y clang uuid-dev meson pkg-config cmake libcmocka-dev cargo
  82. flashmap_src=/root/flashmap
  83. mosys_src=/root/mosys
  84. mkdir $flashmap_src
  85. mkdir $mosys_src
  86. #clone flashmap, need to build libfmap
  87. git clone https://github.com/dhendrix/flashmap.git /root/flashmap
  88. cd $flashmap_src && make all
  89. cd $flashmap_src && make install
  90. ldconfig
  91. #clone mosys. Later releases start depending on the minijail library which we would have to build, and that we don't care about anyway on linux
  92. git clone https://chromium.googlesource.com/chromiumos/platform/mosys /root/mosys
  93. cd $mosys_src && git checkout release-R69-10895.B
  94. mkdir $mosys_src/build
  95. # compile the c parts
  96. cd $mosys_src && CFLAGS="-Wno-error" CC=clang meson -Darch=arm $mosys_src/build
  97. cd $mosys_src && ninja -C $mosys_src/build
  98. # install mosys so crossystem can access it. It EXPECTS it to be right here and fails otherwise...
  99. mkdir -p /usr/sbin/
  100. cp --verbose $mosys_src/build/mosys /usr/sbin/
  101. # cleanup the source
  102. rm -rf $flashmap_src
  103. rm -rf $mosys_src
  104. # cleanup the unnecessary build packages, need the noninteractive flag as -y is not enough to avoid prompting users on remove for some reason
  105. DEBIAN_FRONTEND=noninteractive apt-get purge -y --auto-remove clang meson libcmocka-dev cargo cmake pkg-config
  106. }
  107. # create a 2GB image with the Chrome OS partition layout
  108. create_image $BASE $outdev 50M 40 $outmnt
  109. # use default debootstrap mirror if none is specified
  110. if [ "$PRAWNOS_DEBOOTSTRAP_MIRROR" = "" ]
  111. then
  112. PRAWNOS_DEBOOTSTRAP_MIRROR=http://ftp.us.debian.org/debian
  113. fi
  114. # install Debian on it
  115. export DEBIAN_FRONTEND=noninteractive
  116. qemu-debootstrap --arch armhf $DEBIAN_SUITE --include locales,init --keyring=$build_resources/debian-archive-keyring.gpg $outmnt $PRAWNOS_DEBOOTSTRAP_MIRROR
  117. chroot $outmnt passwd -d root
  118. #Place the config files and installer script and give them the proper permissions
  119. echo -n PrawnOS > $outmnt/etc/hostname
  120. cp -R $install_resources/ $outmnt/InstallResources/
  121. # and the icons for the lockscreen and app menu
  122. mkdir $outmnt/InstallResources/icons/
  123. cp $build_resources/logo/icons/icon-small.png $outmnt/InstallResources/icons/
  124. cp $build_resources/logo/icons/ascii/* $outmnt/InstallResources/icons/
  125. cp scripts/InstallScripts/* $outmnt/InstallResources/
  126. cp scripts/InstallScripts/InstallPrawnOS.sh $outmnt/
  127. chmod +x $outmnt/*.sh
  128. #Setup the chroot for apt
  129. #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
  130. cp /etc/hosts $outmnt/etc/
  131. cp $build_resources/sources.list $outmnt/etc/apt/sources.list
  132. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list
  133. if [ "$DEBIAN_SUITE" != "sid" ]
  134. then
  135. # sid doesn't have updates or security; they're present for all other suites
  136. cat $build_resources/updates.list >> $outmnt/etc/apt/sources.list
  137. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list
  138. # sid doesn't have backports; it's present for all other suites
  139. cp $build_resources/backports.list $outmnt/etc/apt/sources.list.d/
  140. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list.d/backports.list
  141. #setup apt pinning
  142. cp $build_resources/backports.pref $outmnt/etc/apt/preferences.d/
  143. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/preferences.d/backports.pref
  144. # Install sid (unstable) as an additional source for bleeding edge packages.
  145. cp $build_resources/sid.list $outmnt/etc/apt/sources.list.d/
  146. #setup apt pinning
  147. cp $build_resources/sid.pref $outmnt/etc/apt/preferences.d/
  148. fi
  149. if [ "$DEBIAN_SUITE" = "buster" ]
  150. then
  151. # Install bullseye (testing) as an additional source
  152. cp $build_resources/bullseye.list $outmnt/etc/apt/sources.list.d/
  153. #setup apt pinning
  154. cp $build_resources/bullseye.pref $outmnt/etc/apt/preferences.d/
  155. fi
  156. #Setup the locale
  157. cp $build_resources/locale.gen $outmnt/etc/locale.gen
  158. chroot $outmnt locale-gen
  159. #Install the base packages
  160. chroot $outmnt apt update
  161. chroot $outmnt apt install -y udev kmod net-tools inetutils-ping traceroute iproute2 isc-dhcp-client wpasupplicant iw alsa-utils cgpt vim-tiny less psmisc netcat-openbsd ca-certificates bzip2 xz-utils ifupdown nano apt-utils git kpartx gdisk parted rsync busybox-static cryptsetup bash-completion libnss-systemd libpam-cap nftables uuid-runtime libgpg-error-l10n libatm1 laptop-detect e2fsprogs-l10n vim
  162. #build and install crossystem/mosys, funky way to call the bash function inside the chroot
  163. export -f build_install_crossystem
  164. chroot $outmnt /bin/bash -ec "build_install_crossystem"
  165. #add the live-boot fstab
  166. cp -f $build_resources/external_fstab $outmnt/etc/fstab
  167. chmod 644 $outmnt/etc/fstab
  168. #Cleanup to reduce install size
  169. chroot $outmnt apt-get autoremove --purge
  170. chroot $outmnt apt-get clean
  171. #Download support for libinput-gestures
  172. chroot $outmnt apt install -y libinput-tools xdotool build-essential
  173. #Package is copied into /InstallResources/packages
  174. chroot $outmnt apt-get install -y -t testing -d xsecurelock
  175. #Download the packages to be installed by Install.sh:
  176. chroot $outmnt apt-get install -y -d xorg acpi-support lightdm tasksel dpkg librsvg2-common xorg xserver-xorg-input-libinput alsa-utils anacron avahi-daemon eject iw libnss-mdns xdg-utils lxqt crda xfce4 dbus-user-session system-config-printer tango-icon-theme xfce4-power-manager xfce4-terminal xfce4-goodies mousepad vlc libutempter0 xterm numix-gtk-theme dconf-cli dconf-editor plank network-manager-gnome network-manager-openvpn network-manager-openvpn-gnome dtrx emacs accountsservice sudo pavucontrol-qt papirus-icon-theme sysfsutils bluetooth
  177. chroot $outmnt apt-get install -d -y firefox-esr
  178. # grab chromium as well, since sound is still broken in firefox for some media
  179. #Cleanup hosts
  180. rm -rf $outmnt/etc/hosts #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
  181. echo -n "127.0.0.1 PrawnOS" > $outmnt/etc/hosts
  182. umount -l $outmnt > /dev/null 2>&1
  183. rmdir $outmnt > /dev/null 2>&1
  184. losetup -d $outdev > /dev/null 2>&1
  185. echo "DONE!"
  186. trap - INT TERM EXIT